package cn.com.infosec.asn1.teletrust;

import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.x9.X9ECParameters;
import cn.com.infosec.asn1.x9.X9ECParametersHolder;
import cn.com.infosec.util.Strings;
import java.util.Enumeration;
import java.util.Hashtable;

public class TeleTrusTNamedCurves {
   static X9ECParametersHolder brainpoolP160r1 = new TeleTrusTNamedCurves$1();
   static X9ECParametersHolder brainpoolP160t1 = new TeleTrusTNamedCurves$2();
   static X9ECParametersHolder brainpoolP192r1 = new TeleTrusTNamedCurves$3();
   static X9ECParametersHolder brainpoolP192t1 = new TeleTrusTNamedCurves$4();
   static X9ECParametersHolder brainpoolP224r1 = new TeleTrusTNamedCurves$5();
   static X9ECParametersHolder brainpoolP224t1 = new TeleTrusTNamedCurves$6();
   static X9ECParametersHolder brainpoolP256r1 = new TeleTrusTNamedCurves$7();
   static X9ECParametersHolder brainpoolP256t1 = new TeleTrusTNamedCurves$8();
   static X9ECParametersHolder brainpoolP320r1 = new TeleTrusTNamedCurves$9();
   static X9ECParametersHolder brainpoolP320t1 = new TeleTrusTNamedCurves$10();
   static X9ECParametersHolder brainpoolP384r1 = new TeleTrusTNamedCurves$11();
   static X9ECParametersHolder brainpoolP384t1 = new TeleTrusTNamedCurves$12();
   static X9ECParametersHolder brainpoolP512r1 = new TeleTrusTNamedCurves$13();
   static X9ECParametersHolder brainpoolP512t1 = new TeleTrusTNamedCurves$14();
   static final Hashtable objIds = new Hashtable();
   static final Hashtable curves = new Hashtable();
   static final Hashtable names = new Hashtable();

   static {
      X9ECParametersHolder var0 = brainpoolP160r1;
      defineCurve("brainpoolp160r1", TeleTrusTObjectIdentifiers.brainpoolP160r1, var0);
      var0 = brainpoolP160t1;
      defineCurve("brainpoolp160t1", TeleTrusTObjectIdentifiers.brainpoolP160t1, var0);
      var0 = brainpoolP192r1;
      defineCurve("brainpoolp192r1", TeleTrusTObjectIdentifiers.brainpoolP192r1, var0);
      var0 = brainpoolP192t1;
      defineCurve("brainpoolp192t1", TeleTrusTObjectIdentifiers.brainpoolP192t1, var0);
      var0 = brainpoolP224r1;
      defineCurve("brainpoolp224r1", TeleTrusTObjectIdentifiers.brainpoolP224r1, var0);
      var0 = brainpoolP224t1;
      defineCurve("brainpoolp224t1", TeleTrusTObjectIdentifiers.brainpoolP224t1, var0);
      var0 = brainpoolP256r1;
      defineCurve("brainpoolp256r1", TeleTrusTObjectIdentifiers.brainpoolP256r1, var0);
      var0 = brainpoolP256t1;
      defineCurve("brainpoolp256t1", TeleTrusTObjectIdentifiers.brainpoolP256t1, var0);
      var0 = brainpoolP320r1;
      defineCurve("brainpoolp320r1", TeleTrusTObjectIdentifiers.brainpoolP320r1, var0);
      var0 = brainpoolP320t1;
      defineCurve("brainpoolp320t1", TeleTrusTObjectIdentifiers.brainpoolP320t1, var0);
      var0 = brainpoolP384r1;
      defineCurve("brainpoolp384r1", TeleTrusTObjectIdentifiers.brainpoolP384r1, var0);
      var0 = brainpoolP384t1;
      defineCurve("brainpoolp384t1", TeleTrusTObjectIdentifiers.brainpoolP384t1, var0);
      var0 = brainpoolP512r1;
      defineCurve("brainpoolp512r1", TeleTrusTObjectIdentifiers.brainpoolP512r1, var0);
      var0 = brainpoolP512t1;
      defineCurve("brainpoolp512t1", TeleTrusTObjectIdentifiers.brainpoolP512t1, var0);
   }

   static void defineCurve(String name, DERObjectIdentifier oid, X9ECParametersHolder holder) {
      objIds.put(name, oid);
      names.put(oid, name);
      curves.put(oid, holder);
   }

   public static X9ECParameters getByName(String name) {
      DERObjectIdentifier name1;
      return (name1 = (DERObjectIdentifier)objIds.get(Strings.toLowerCase(name))) != null ? getByOID(name1) : null;
   }

   public static X9ECParameters getByOID(DERObjectIdentifier oid) {
      X9ECParametersHolder oid1;
      return (oid1 = (X9ECParametersHolder)curves.get(oid)) != null ? oid1.getParameters() : null;
   }

   public static DERObjectIdentifier getOID(String name) {
      return (DERObjectIdentifier)objIds.get(Strings.toLowerCase(name));
   }

   public static String getName(DERObjectIdentifier oid) {
      return (String)names.get(oid);
   }

   public static Enumeration getNames() {
      return objIds.keys();
   }

   public static DERObjectIdentifier getOID(short curvesize, boolean twisted) {
      StringBuffer curvesize1 = (new StringBuffer("brainpoolP")).append(curvesize);
      String twisted1;
      if (twisted) {
         twisted1 = "t";
      } else {
         twisted1 = "r";
      }

      return getOID(curvesize1.append(twisted1).append("1").toString());
   }
}
